
TYPO3.Flow - Bug # 31677

Status: Resolved Priority: Must have
Author: Ferdinand Kuhl Category: Security
Created: 2011-11-08 Assigned To:
Updated: 2012-04-26 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: Git master
Subject: Using current.securityContext Policies.yaml entities section triggers Parser Error
Description

If you use some Content Security Rule like:

resources:
  entities:
    DigiComp_Fairdrive_Domain_Model_Disposition:
      DigiComp_Fairdrive_ForeignDispositions: this.createdfrom != current.securityContext.party

FLOW3 will crash completely with:

: Parse error: syntax error, unexpected $end in
[...]FLOW3/Data/Temporary/Development/Cache/Code/FLOW3_Object_Classes/TYPO3_FLOW3_Security_Aspect_PersistenceQueryRewritingAspect_Original.php(374) : eval()'d c
yRewritingAspect_Original.php(374) : eval()'d code

Related issues:
duplicated by TYPO3.Flow - Bug # 32629: globalObjects are not available in th... Closed 2011-12-16

Associated revisions
Revision a5a90def - 2012-04-20 18:24 - Ferdinand Kuhl

[BUGFIX] Fix content security current.globalObject expansion

Using for example current.securityContext in Policy.yaml made
FLOW3 crash completely in "eval'd" code.

This fixes the crash and removes the eval code by using the
TYPO3\FLOW3\Object\ObjectManager.

Change-Id: I0a5e0b13339b8571ef043da7dbe34b1c9285deed
Fixes: #31677
Releases: 1.1

History
#1 - 2011-11-08 14:10 - Mr. Hudson
- Status changed from New to Under Review

Patch set 1 of change I0a5e0b13339b8571ef043da7dbe34b1c9285deed has been pushed to the review server.
It is available at http://review.typo3.org/6596
#2 - 2011-11-08 20:45 - Mr. Hudson

Patch set 2 of change I0a5e0b13339b8571ef043da7dbe34b1c9285deed has been pushed to the review server.
It is available at http://review.typo3.org/6596

#3 - 2011-11-08 23:52 - Mr. Hudson

Patch set 3 of change I0a5e0b13339b8571ef043da7dbe34b1c9285deed has been pushed to the review server.
It is available at http://review.typo3.org/6596

#4 - 2011-11-08 23:54 - Mr. Hudson

Patch set 4 of change I0a5e0b13339b8571ef043da7dbe34b1c9285deed has been pushed to the review server.
It is available at http://review.typo3.org/6596

#5 - 2011-11-16 10:03 - Christopher Hlubek

Moving over the test discussion here:

We already have functional tests for persistence with entities and repositories in the TYPO3\FLOW3\Tests\Functional\Persistence\Fixtures
namespace. Also the Configuration in TYPO3.FLOW3/Configuration/Testing/Policy.yaml could be used for testing (with some comment about the
usage).

I think a functional test for content security would best go into a new testcase TYPO3\FLOW3\Tests\Functional\Security\ContentSecurityTest. Take a
look at the MethodSecurityTest for a hint about how to authorize different roles in a functional test.

To run a functional test you have to use the FunctionalTests.xml PHPUnit configuration in Build/Common/PhpUnit. For example in the FLOW3 package
directory you can call phpunit -c ../../../Build/Common/PhpUnit/FunctionalTests.xml Tests/Functional to run the functional tests.

The test should first cause the error (without your change) and then pass after your fix.

#6 - 2011-12-23 17:03 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6596

#7 - 2012-01-20 15:31 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6596

#8 - 2012-01-20 16:27 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6596
#9 - 2012-02-25 23:52 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6596

#10 - 2012-02-29 23:49 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6596

#11 - 2012-03-15 20:07 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6596

#12 - 2012-04-11 15:24 - Rens Admiraal
- Target version set to 1.1

#13 - 2012-04-11 15:38 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6596

#14 - 2012-04-20 15:05 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6596

#15 - 2012-04-20 22:50 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6596

#16 - 2012-04-26 14:38 - Ferdinand Kuhl
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:a5a90def350b789e0758982b97bd9d27b20576a5.
